// Rounded triangle guitar picky thing
// Radius calculation: https://en.wikipedia.org/wiki/Regular_polygon#Circumradius

ChipCorners = 3;                            // makes guitar pick or circle?

ChipSide = 20.0;                            // overall side length
ChipThick = 2.0;                            // thickness of top half

CornerRad = ChipThick;                      // corner rounding in XY plane

CircumRad = ChipSide / (2*sin(180/ChipCorners));    // center to (sharp) corner
echo(str("Circumradius: ",CircumRad));

Apothem = CircumRad * cos(180/ChipCorners);         // center to (sharp) side
echo(str("Apothem: ",Apothem));

ChipAngle = 360/ChipCorners;                // angle between sides

CornerSides = 5*ChipCorners;                // 3 may be lower limit of prettiness

// Generate chip shape

module Chip(Side) {
  hull()                                                  // shrinkwrap the spheres
    for (i=[0 : ChipCorners-1])                           // for each corner
      rotate(i*360/ChipCorners)                           // turn it into proper position
        translate([Side / (2*sin(180/ChipCorners)),0,0])  // put sphere out there
          resize([0,0,2*ChipThick])                       // match sphere Z dia to chip thickness
            rotate(180/CornerSides)                       // aim a flat side to corner
              sphere(r=CornerRad,$fn=CornerSides);        // create a sphere
}

// Build the chip

intersection() {
  Chip(ChipSide);                                         // basic chip shape

#  rotate(180/ChipCorners)
  Chip(ChipSide * CircumRad/Apothem  - 1*CornerRad);      // enlarged chip shape

  translate([0,0,ChipThick])                              // include only top half
    cube([4*ChipSide,4*ChipSide,2*ChipThick],center=true);
}
