// Rounded triangle guitar picky thing
// Radius calculation: https://en.wikipedia.org/wiki/Regular_polygon#Circumradius

ShowSpheres = true;

ChipCorners = 3;                            // makes guitar pick or circle?

ChipSide = 20.0;                            // overall side length, including rounding
ChipThick = 2.0;                            // chip thickness

CornerRad = 2*ChipThick;                      // corner rounding in XY plane

CircumRad = ChipSide / (2*sin(180/ChipCorners));    // center to (sharp) corner
echo(str("Circumradius: ",CircumRad));

ChipAngle = 360/ChipCorners;                // angle between sides

CornerSides = 5*ChipCorners;                // 3 may be lower limit of prettiness

difference() {
  hull()                                                // shrinkwrap the spheres
    for (i=[0 : ChipCorners - 1])                       // for each corner
      rotate(i*360/ChipCorners)                         // turn it into proper position
        translate([CircumRad - CornerRad,0,0])          // put sphere out there
          resize([0,0,2*ChipThick])                     // match sphere Z dia to chip thickness
            rotate(180/CornerSides)                     // aim a flat side to corner
              sphere(r=CornerRad,$fn=CornerSides);      // create a sphere

  translate([0,0,-ChipThick])
    cube([4*ChipSide,4*ChipSide,2*ChipThick],center=true);

}

Visibility = 0.001;
if (ShowSpheres)
  color("Green")
      for (i=[0 : ChipCorners - 1])                       // for each corner
        rotate(i*360/ChipCorners)                         // turn it into proper position
          translate([CircumRad - CornerRad,0,0])          // put sphere out there
            resize([0,0,2*ChipThick + Visibility])        // match sphere Z dia to chip thickness
              rotate(180/CornerSides)                     // aim a flat side to corner
                sphere(r=CornerRad + Visibility,$fn=CornerSides);      // create a sphere