// Rounded triangle guitar picky thing
// Radius calculation: https://en.wikipedia.org/wiki/Regular_polygon#Circumradius

TopHalf = true;                             // true to slice off the bottom half
Emboss = true;                              // true to emboss painting guide

ChipCorners = 3;                            // makes guitar pick or circle?

ChipSide = 20.0;                            // overall side length, including rounding
ChipThick = 3.0;                            // overall thickness (2 * flat-bottom thickness)

CornerRad = 0.5;                            // corner rounding in XY plane

EmbossDepth = 0.20;                         // about one thread thickness
EmbossRatio = 0.25;                         // XY size of center feature

CircumRad = ChipSide / (2*sin(180/ChipCorners));    // center to (sharp) corner
echo(str("Circumradius: ",CircumRad));

ChipAngle = 360/ChipCorners;                // angle between sides

CornerSides = 5*ChipCorners;                // 3 may be lower limit of prettiness

difference() {
  hull()                                                // shrinkwrap the spheres
    for (i=[0 : ChipCorners - 1])                       // for each corner
      rotate(i*360/ChipCorners)                         // turn it into proper position
        translate([CircumRad - CornerRad,0,0])          // put sphere out there
          resize([0,0,ChipThick])                       // match sphere Z dia to chip thickness
            rotate(180/CornerSides)                     // aim a flat side to corner
              sphere(r=CornerRad,$fn=CornerSides);      // create a sphere

  if (TopHalf)                              // remove bottom half of chip?
    translate([0,0,-ChipThick/2])
      cube([4*ChipSide,4*ChipSide,ChipThick],center=true);

  if (Emboss)                               // punch painting guide?
    translate([0,0,ChipThick/2 - EmbossDepth])
      cylinder(r=EmbossRatio*CircumRad,$fn=ChipCorners);
}
